package compiler;

import java.io.File;
import java.lang.reflect.InvocationTargetException;
import java.util.Arrays;

import lowLevel.eval.Eval;
import structure.integrity.IntegrityChecker;
import tools.*;
import visitors.VisitorTranslateZero;

public class Mfj {
  public static void main(String[] args) {
    try {
      if (args.length != 1) {
        System.out.println("use with inputFolder, you give " + Arrays.asList(args));
        return;
      }
      Mfjc.setDir(new File(args[0]), null);
      Eval.setDir(new File(args[0]), Mfjc.getLoader());
      invokeMain();
      System.exit(0);
    } catch (Throwable t) {
      ReportingHelpers.printAllAbout(t);
      System.exit(1);
    }
  }
  
  public static void invokeMain() {
    try {
      invokeMainAux();
    } catch (IllegalArgumentException e) {
      Assertions.reflectionError("", e);
    } catch (SecurityException e) {
      Assertions.reflectionError("", e);
    } catch (ClassNotFoundException e) {
      Assertions.reflectionError("", e);
    } catch (IllegalAccessException e) {
      Assertions.reflectionError("", e);
    } catch (InvocationTargetException e) {
      if (e.getCause() instanceof RuntimeException) throw (RuntimeException) e.getCause();
      if (e.getCause() instanceof Error) throw (Error) e.getCause();
      throw Assertions.codeNotReachable();
    }
  }
  private static void invokeMainAux() throws ClassNotFoundException, IllegalArgumentException, SecurityException, IllegalAccessException,
      InvocationTargetException {
    Class<?> mainClass = FileManager.loadClassDiskWait(Mfjc.programCode + "." + IntegrityChecker.forbiddenPrefix
        + VisitorTranslateZero.generationNumber + "Main", Mfjc.getLoader());
    mainClass.getMethods()[0].invoke(null, (Object) new String[0]);
  }
}