package lowLevel.producer;

import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import javax.tools.*;

import tools.Assertions;

class PackageRespect extends ForwardingJavaFileManager<JavaFileManager> {
  File dir;
  
  protected PackageRespect(File dir, JavaFileManager fileManager) {
    super(fileManager);
    this.dir = dir;
  }
  
  public URI fromName(String name) {
    String[] paths = name.split("\\.");
    String path = dir.getAbsolutePath();
    for (int i = 0; i < paths.length - 1; i++)
      path += File.separator + paths[i];
    File fPath = new File(path);
    fPath.mkdirs();
    name = path + File.separator + paths[paths.length - 1] + ".class";
    File f = new File(name);
    return f.toURI();
  }
  @Override
  public JavaFileObject getJavaFileForOutput(JavaFileManager.Location location, String className, JavaFileObject.Kind kind, FileObject sibling)
      throws IOException {
    try {
      return new DiskClassFile(fromName(className));
    } catch (URISyntaxException e) {
      throw Assertions.userErrorAssert("Incorret name", e);
    }
    
  }
}

/* @Override
public JavaFileObject getJavaFileForInput(JavaFileManager.Location location, String className, JavaFileObject.Kind kind) throws IOException {
  return super.getJavaFileForInput(location, className, kind);
}*/

/*@Override
public FileObject getFileForInput(JavaFileManager.Location location, String packageName, String relativeName) throws IOException {
 return super.getFileForInput(location, packageName, relativeName);
}*/

/* @Override
public boolean hasLocation(JavaFileManager.Location location) {
  return super.hasLocation(location);
}*/

/*
class MyFilenameFilter implements FilenameFilter {
  String name;
  
  MyFilenameFilter(String name) {
    this.name = name;
  }
  
  @Override
  public boolean accept(File arg0, String arg1) {
    return arg1.equals(name);
  }
}
*/