package mainProgram;

import java.io.File;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.Arrays;

import javax.swing.JOptionPane;

import lowLevel.producer.JavaProducer;

import compiler.Mfj;
import compiler.Mfjc;

public class Main {
  public static final String defaultOut = "defaultOut";
  
  private static String isCompatible() {
    String errorMsg = "\n\n-----------------------------------------------------------\n" + //
        "This program requires a JDK 6 Java environment\n" + //
        "you are now using a JRE Java environment,\n" + //
        "that do not include the Java compiler.\n" + //
        "Please run this program using\n" + //
        "a JDK 6, for example:\n" + //
        "C:\\Programs\\Java\\jdk1.6.0_17\\bin\\java -jar MFJ.jar\n" + //
        "-----------------------------------------------------------\n";
    String errorMsg2 = "\n\n-----------------------------------------------------------\n" + //
        "This program requires a JDK 6 Java environment or later.\n" + //
        "-----------------------------------------------------------\n";
    
    try {
      if (JavaProducer.compiler == null) return errorMsg;
    } catch (Throwable t) {
      return errorMsg2;
    }
    return null;
  }
  public static void main(String[] args) throws Throwable {
    String msg = isCompatible();
    if (msg != null) {
      if (args.length == 0) //using GUI
        JOptionPane.showMessageDialog(null, msg, "JDK required", JOptionPane.ERROR_MESSAGE);
      System.err.println(msg);
      System.exit(1);
    }
    if (args.length == 0) {
      //hackCP();
      graphicApplication.MainGui.main(args);
    } else if (args.length >= 1) {
      if (args[0].equals("compile")) compile(args);
      else if (args[0].equals("execute")) execute(args);
      else System.err.println("Unreconized parameter " + args[0]);
      
    }
  }
  private static void hackCP() throws Exception {
    Method addURL = URLClassLoader.class.getDeclaredMethod("addURL", new Class[]{URL.class});
    addURL.setAccessible(true);
    File[] files = new File[]{new File(defaultOut)};
    ClassLoader cl = ClassLoader.getSystemClassLoader();
    for (int i = 0; i < files.length; i++) {
      URL url = files[i].toURI().toURL();
      addURL.invoke(cl, new Object[]{url});
    }
  }
  private static void execute(String[] args) throws Throwable {
    if (args.length != 2) {
      System.err.println("use with inputFolder, you give " + Arrays.asList(args));
      return;
    }
    Mfj.main(new String[]{args[1]});
    
  }
  private static void compile(String[] args) throws Throwable {
    if (args.length != 3) {
      System.err.println("use with inputName outputFolder, you give " + Arrays.asList(args));
      return;
    }
    Mfjc.main(new String[]{args[1], args[2]});
    
  }
}
