package primitiveOperation;

import java.util.HashSet;

import structure.astNode.Ast.ClassName;
import structure.astNode.Ast.Expression;
import structure.integrity.IntegrityChecker;
import structure.program.ClassTable;
import structure.resource.GreenResource;
import structure.resource.YellowResource.NormalizedYellowResource;
import visitors.VisitorCollectUsedTypesStar;
import visitors.VisitorCollectUsedTypesZero;

public class IsClosed {
  public static boolean expression(ClassTable ct, Expression e) {
    HashSet<ClassName> used = new VisitorCollectUsedTypesZero().run(e);
    used.removeAll(ct.keySet(GreenResource.class));
    used.removeAll(IntegrityChecker.predefinedTypesAndClasses);
    return used.isEmpty();
  }
  public static boolean resource(ClassTable ct, NormalizedYellowResource e) {
    HashSet<ClassName> used = new VisitorCollectUsedTypesStar().run(e.expression);
    used.removeAll(ct.keySet(GreenResource.class));
    used.removeAll(IntegrityChecker.predefinedTypesAndClasses);
    used.remove(e.name);
    return used.isEmpty();
  }
}
