package primitiveOperation;

import java.lang.reflect.InvocationTargetException;
import java.util.Collection;

import primitiveType.MFJClass;
import structure.program.ClassTable;
import structure.resource.YellowResource.MetaYellowResource;
import structure.resource.YellowResource.NormalizedYellowResource;
import tools.Assertions;

public class NormalizeYellow {
  public static boolean run(ClassTable ct) {
    Collection<MetaYellowResource> v = ct.values(MetaYellowResource.class);
    if (v.isEmpty()) return false;
    MetaYellowResource first = v.iterator().next();
    try {
      Object oResult = first.expression.invoke();
      MFJClass result = (MFJClass) oResult;
      NormalizedYellowResource n = new NormalizedYellowResource(first.name, result.__extractCLZero());
      ct.remove(MetaYellowResource.class, first.name);
      ct.put(first.name, n);
      
    } catch (InvocationTargetException e) {
      if (e.getCause() instanceof RuntimeException) throw (RuntimeException) e.getCause();
      if (e.getCause() instanceof Error) throw (Error) e.getCause();
      throw Assertions.codeNotReachable();
    } catch (IllegalArgumentException e) {
      throw Assertions.codeNotReachable();
    } catch (IllegalAccessException e) {
      throw Assertions.codeNotReachable();
    }
    return true;
  }
}
