package primitiveOperation;

import java.util.*;

import structure.astNode.Ast.ClassName;
import structure.integrity.IntegrityChecker;
import structure.program.ClassTable;
import structure.resource.GreenResource;
import structure.resource.YellowResource.NormalizedYellowResource;
import visitors.VisitorCollectUsedTypesStar;

public class ProduceBiggherClosedSubset {
  public static Collection<NormalizedYellowResource> run(ClassTable ct) {
    
    Set<ClassName> green = ct.keySet(GreenResource.class);
    Set<ClassName> yellow = ct.keySet(NormalizedYellowResource.class);
    Collection<NormalizedYellowResource> yellowV = ct.values(NormalizedYellowResource.class);
    HashMap<ClassName, Set<ClassName>> usages = new HashMap<ClassName, Set<ClassName>>();
    for (NormalizedYellowResource n : yellowV) {
      usages.put(n.name, new VisitorCollectUsedTypesStar().run(n.expression));
    }
    HashSet<ClassName> allowed = new HashSet<ClassName>(green);
    allowed.addAll(IntegrityChecker.predefinedTypesAndClasses);
    allowed.addAll(yellow);
    loop : while (true) {
      for (ClassName n : yellow) {
        if (allowed.containsAll(usages.get(n))) continue;
        yellow.remove(n);
        allowed.remove(n);
        continue loop;
      }
      break;
    }
    ArrayList<NormalizedYellowResource> result = new ArrayList<NormalizedYellowResource>();
    for (ClassName n : yellow)
      result.add(ct.get(NormalizedYellowResource.class, n));
    return result;
  }
  
}
