package primitiveOperation;

import java.util.Collection;

import lowLevel.eval.Eval;
import lowLevel.eval.Eval.CompiledExpression;
import lowLevel.producer.JavaCompilationError;
import structure.astNode.Ast.BaseClassValue;
import structure.astNode.Ast.ClassName;
import structure.program.ClassTable;
import structure.resource.Resource;
import structure.resource.YellowResource;
import structure.resource.YellowResource.MetaYellowResource;

public class RedToYellow {
  public static boolean run(ClassTable ct) throws MetaChecRedToYellowError, CircularityError {
    {
      ClassName n = IsCircular.exampleOfCircularity(ct);
      if (n != null) throw new CircularityError(n);
    }
    Collection<Resource> red = ct.values(Resource.class);
    for (Resource r : red) {
      if (!IsClosed.expression(ct, r.expression)) continue;
      YellowResource m;
      if (r.expression instanceof BaseClassValue) {
        m = new YellowResource.NormalizedYellowResource(r.name, (BaseClassValue) r.expression);
      } else {
        StringBuffer eJ = TranslateExpression.run(r.expression);
        CompiledExpression eC;
        try {
          eC = Eval.compile(eJ.toString());
        } catch (JavaCompilationError e) {
          throw new MetaChecRedToYellowError(e);
        }
        m = new MetaYellowResource(r.name, r.expression, eC);
      }
      ct.remove(Resource.class, r.name);
      ct.put(r.name, m);
      return true;
    }
    return false;
    
  }
}
