package primitiveOperation;

import java.util.*;

import structure.astNode.Ast.BaseClassValue;
import structure.program.ClassTable;
import structure.resource.YellowResource.NormalizedYellowResource;
import visitors.VisitorCollectBaseClassValue;
import visitors.VisitorTranslateZero;

public class TranslateStar {
  public static HashMap<String, StringBuffer> run(Collection<NormalizedYellowResource> metaP, ClassTable ct) {
    HashMap<String, StringBuffer> result = new HashMap<String, StringBuffer>();
    for (NormalizedYellowResource r : metaP) {
      result.putAll(run(ct, r));
    }
    return result;
  }
  
  private static HashMap<String, StringBuffer> run(ClassTable ct, NormalizedYellowResource r) {
    HashSet<BaseClassValue> under = new VisitorCollectBaseClassValue().run(r.expression);
    under.remove(r.expression);
    HashMap<String, StringBuffer> result = new HashMap<String, StringBuffer>();
    run(result, r.name.value, ct, r.expression);
    for (BaseClassValue b : under) {
      String fName = fresh();
      run(result, fName, ct, b);
    }
    return result;
  }
  private static void run(HashMap<String, StringBuffer> result, String name, ClassTable ct, BaseClassValue bc) {
    result.put(VisitorTranslateZero.cDecName(name), new VisitorTranslateZero(name).runBaseClassValue(ct, bc));
    result.put(VisitorTranslateZero.iDecName(name), new VisitorTranslateZero(name).runInterface(bc));
  }
  private static int freshCount = 0;
  private static String fresh() {
    return "freshName" + (freshCount++);
  }
}
