package primitiveOperation;

import java.util.Collection;
import java.util.HashMap;

import lowLevel.generate.Generate;
import lowLevel.producer.JavaCompilationError;
import structure.program.ClassTable;
import structure.resource.GreenResource;
import structure.resource.YellowResource.NormalizedYellowResource;

public class YellowToGreen {
  public static boolean run(ClassTable ct) throws YellowToGreenError {
    Collection<NormalizedYellowResource> closed = ProduceBiggherClosedSubset.run(ct);
    if (closed.isEmpty()) return false;
    HashMap<String, StringBuffer> translated = TranslateStar.run(closed, ct);
    try {
      Generate.javaGeneration(translated);
    } catch (JavaCompilationError e) {
      throw new YellowToGreenError(e);
    }
    for (NormalizedYellowResource r : closed)
      ct.remove(NormalizedYellowResource.class, r.name);
    for (NormalizedYellowResource r : closed)
      ct.put(r.name, new GreenResource(r.name));
    return true;
    
  }
}
