package primitiveType;

public interface PredefinedExceptions {
  String getMessage();
  public static abstract class CompositionException extends RuntimeException {
    public CompositionException(String message) {
      super(message);
    }
  }
  
  public static interface ICompositionException {}
  public static interface IRestrictException extends ICompositionException {}
  public static interface IAliasException extends ICompositionException {}
  public static interface IRedirectException extends ICompositionException {}
  public static interface ISumException extends ICompositionException {}
  public static class RestrictException extends CompositionException implements IRestrictException {
    public RestrictException(String message) {
      super(message);
    }
  }
  public static class AliasException extends CompositionException implements IAliasException {
    public AliasException(String message) {
      super(message);
    }
  }
  public static class RedirectException extends CompositionException implements IRedirectException {
    public RedirectException(String message) {
      super(message);
    }
  }
  public static class SumException extends CompositionException implements ISumException {
    public SumException(String message) {
      super(message);
    }
  }
}
