package strategy;

import primitiveOperation.*;
import structure.program.ClassTable;
import tools.Assertions;
import tools.DataStructures;

public class MakeOneStep {
  public static enum StepName {
    YellowToGreen(" rule (CHECK)"), //
    YellowToGreenError(" rule (CHECK-ERROR)"), //
    NormalizeYellow(" rule (META-RED)"), //
    NormalizeYellowError(" rule (META-RED-ERROR)"), //
    RedToYellow(" rule (META-CHECK)"), //
    RedToYellowError(" rule (META-CHECK-ERROR)");
    StepName(String _repr) {
      this._repr = _repr;
    }
    String _repr;
    public String repr() {
      return _repr;
    }
  }
  public static StepName run(ClassTable ct) throws MetaChecRedToYellowError, YellowToGreenError, CircularityError {
    if (YellowToGreen.run(ct)) return StepName.YellowToGreen;
    try {
      if (NormalizeYellow.run(ct)) return StepName.NormalizeYellow;
    } catch (RuntimeException e) {
      throw new DataStructures.WrapperException(e);
    }
    if (RedToYellow.run(ct)) return StepName.RedToYellow;
    throw Assertions.codeNotReachable();
    
  }
}
