package structure.astNode;

import structure.astNode.Ast.*;
import structure.astNode.Ast.StringValue;

class EqualAst {
  /*public static boolean areEquals(Ast e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    return e.accept(new VisitorEqual(b));
  }*/
  public static boolean areEquals(IntValue e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    return e.value == ((IntValue) b).value;
  }
  public static boolean areEquals(StringValue e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    return e.value.equals(((StringValue) b).value);
  }
  public static boolean areEquals(BoolValue e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    return e.value == ((BoolValue) b).value;
  }
  public static boolean areEquals(ClassNameValue e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    return e.value.equals(((ClassNameValue) b).value);
  }
  public static boolean areEquals(MemberNameValue e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    return e.value.equals(((MemberNameValue) b).value);
  }
  public static boolean areEquals(ClassName e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    return e.value.equals(((ClassName) b).value);
  }
  public static boolean areEquals(MemberName e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    return e.value.equals(((MemberName) b).value);
  }
  public static boolean areEquals(VariableName e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    return e.value.equals(((VariableName) b).value);
  }
  
  public static boolean areEquals(VariableAccess e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    VariableAccess bb = (VariableAccess) b;
    return e.value.equals(bb.value);
  }
  public static boolean areEquals(InternalFieldAccess e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    InternalFieldAccess bb = (InternalFieldAccess) b;
    return e.value.equals(bb.value);
  }
  public static boolean areEquals(InternalMethodCall e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    InternalMethodCall bb = (InternalMethodCall) b;
    return e.value.equals(bb.value) //
        && e.params.equals(bb.params);
  }
  public static boolean areEquals(ClientFieldAccess e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    ClientFieldAccess bb = (ClientFieldAccess) b;
    return e.reciver.equals(bb.reciver) //
        && e.value.equals(bb.value);
  }
  public static boolean areEquals(ClientMethodCall e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    ClientMethodCall bb = (ClientMethodCall) b;
    return e.reciver.equals(bb.reciver) //
        && e.value.equals(bb.value) //
        && e.params.equals(bb.params);
  }
  public static boolean areEquals(BaseClassValue e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    BaseClassValue bb = (BaseClassValue) b;
    if (!e.impl.equals(bb.impl)) return false;
    if (!e.members.keySet().equals(bb.members.keySet())) return false;
    for (MemberName m : e.members.keySet())
      if (!e.members.get(Member.class, m).equals(bb.members.get(Member.class, m))) return false;
    return e.constructor.equals(bb.constructor);
  }
  public static boolean areEquals(ParamsDec e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    ParamsDec bb = (ParamsDec) b;
    return e.names.equals(bb.names) && e.types.equals(bb.types);
  }
  public static boolean areEquals(ParamsUse e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    ParamsUse bb = (ParamsUse) b;
    return e.actual.equals(bb.actual);
  }
  public static boolean areEquals(Constructor e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    Constructor bb = (Constructor) b;
    return e.params.equals(bb.params) //
        && e.names.equals(bb.names) //
        && e.expressions.equals(bb.expressions);
  }
  public static boolean areEquals(Field e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    Field bb = (Field) b;
    return e.type.equals(bb.type) && e.name.equals(bb.name);
  }
  public static boolean areEquals(AbstractField e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    AbstractField bb = (AbstractField) b;
    return e.type.equals(bb.type) && e.name.equals(bb.name);
  }
  public static boolean areEquals(Method e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    Method bb = (Method) b;
    return e.returnType.equals(bb.returnType) //
        && e.name.equals(bb.name) //
        && e.params.equals(bb.params) //
        && e.body.equals(bb.body);
  }
  public static boolean areEquals(Block e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    Block bb = (Block) b;
    return e.statements.equals(bb.statements);
  }
  public static boolean areEquals(If e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    If bb = (If) b;
    return e.condition.equals(bb.condition) //
        && e.then.equals(bb.then) //
        && e._else.equals(bb._else);
  }
  public static boolean areEquals(While e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    While bb = (While) b;
    return e.condition.equals(bb.condition) //
        && e.body.equals(bb.body);
  }
  public static boolean areEquals(VariableDeclaration e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    VariableDeclaration bb = (VariableDeclaration) b;
    return e.type.equals(bb.type) //
        && e.name.equals(bb.name) //
        && e.initialization.equals(bb.initialization);
  }
  public static boolean areEquals(Return e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    Return bb = (Return) b;
    return e.expression.equals(bb.expression);
  }
  public static boolean areEquals(AbstractMethod e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    AbstractMethod bb = (AbstractMethod) b;
    return e.returnType.equals(bb.returnType) //
        && e.name.equals(bb.name) //
        && e.params.equals(bb.params);
  }
  public static boolean areEquals(New e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    New bb = (New) b;
    return e.type.equals(bb.type)//
        && e.params.equals(bb.params);
  }
  public static boolean areEquals(NewArray e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    NewArray bb = (NewArray) b;
    return e.type.equals(bb.type)//
        && e.params.equals(bb.params);
  }
  public static boolean areEquals(Print e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    Print bb = (Print) b;
    return e.expression.equals(bb.expression);
  }
  public static boolean areEquals(BinOpExp e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    BinOpExp bb = (BinOpExp) b;
    return e.left.equals(bb.left) //
        && e.op.equals(bb.op) //
        && e.right.equals(bb.right);
  }
  public static boolean areEquals(UnOpExp e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    UnOpExp bb = (UnOpExp) b;
    return e.op.equals(bb.op)//
        && e.inner.equals(bb.inner);
  }
  public static boolean areEquals(RestrictExp e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    RestrictExp bb = (RestrictExp) b;
    return e.targhet.equals(bb.targhet)//
        && e.inner.equals(bb.inner);
  }
  public static boolean areEquals(AliasExp e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    AliasExp bb = (AliasExp) b;
    return e.targhet.equals(bb.targhet)//
        && e.left.equals(bb.left)//
        && e.right.equals(bb.right);
  }
  public static boolean areEquals(RedirectExp e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    RedirectExp bb = (RedirectExp) b;
    return e.targhet.equals(bb.targhet)//
        && e.left.equals(bb.left)//
        && e.right.equals(bb.right);
  }
  public static boolean areEquals(StmExp e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    StmExp bb = (StmExp) b;
    return e.expression.equals(bb.expression);
  }
  public static boolean areEquals(VariableAssignament e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    VariableAssignament bb = (VariableAssignament) b;
    return e.name.equals(bb.name) && e.assignedValue.equals(bb.assignedValue);
  }
  public static boolean areEquals(Throw e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    Throw bb = (Throw) b;
    return e.expression.equals(bb.expression);
  }
  public static boolean areEquals(AccessArray e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    AccessArray bb = (AccessArray) b;
    return e.targhet.equals(bb.targhet) && e.inner.equals(bb.inner);
  }
  public static boolean areEquals(GetMembers e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    GetMembers bb = (GetMembers) b;
    return e.targhet.equals(bb.targhet);
  }
  public static boolean areEquals(Try e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    Try bb = (Try) b;
    return e._try.equals(bb._try)//
        && e.types.equals(bb.types) //
        && e.names.equals(bb.names) //
        && e.blocks.equals(bb.blocks);
  }
  public static boolean areEquals(Foreach e, Object b) {
    if (!e.getClass().equals(b.getClass())) return false;
    Foreach bb = (Foreach) b;
    return e.type.equals(bb.type) //
        && e.name.equals(bb.name) //
        && e.expression.equals(bb.expression) //
        && e.body.equals(bb.body);
  }
  
}