package structure.integrity;

import org.antlr.runtime.RecognitionException;

public abstract class ClassNotWellFormed extends RecognitionException {
  public ClassNotWellFormed(String message) {
    this.message = message;
  }
  public String message;
  public static class ExpressionNotStatement extends ClassNotWellFormed {
    public ExpressionNotStatement(String message) {
      super(message);
    }
  }
  public static class DuplicatedClassDeclaration extends ClassNotWellFormed {
    public DuplicatedClassDeclaration(String message) {
      super(message);
    }
  }
  public static class DuplicatedMemberName extends ClassNotWellFormed {
    public DuplicatedMemberName(String message) {
      super(message);
    }
  }
  public static class DuplicatedParameterName extends ClassNotWellFormed {
    public DuplicatedParameterName(String message) {
      super(message);
    }
  }
  public static class DuplicatedSupertypeName extends ClassNotWellFormed {
    public DuplicatedSupertypeName(String message) {
      super(message);
    }
  }
  public static class ForbiddenId extends ClassNotWellFormed {
    public ForbiddenId(String message) {
      super(message);
    }
  }
  public static class MoreThanOneConstructor extends ClassNotWellFormed {
    public MoreThanOneConstructor(String message) {
      super(message);
    }
  }
  public static class NotInitializedField extends ClassNotWellFormed {
    public NotInitializedField(String message) {
      super(message);
    }
  }
  
  public static class UnboundInternalName extends ClassNotWellFormed {
    public UnboundInternalName(String message) {
      super(message);
    }
  }
  public static class UndefinedVariableAccess extends ClassNotWellFormed {
    public UndefinedVariableAccess(String message) {
      super(message);
    }
  }
  public static class UsegeOfIntenalNameIntoConstructor extends ClassNotWellFormed {
    public UsegeOfIntenalNameIntoConstructor(String message) {
      super(message);
    }
  }
  public static class VariableAlreadyDefined extends ClassNotWellFormed {
    public VariableAlreadyDefined(String message) {
      super(message);
    }
  }
  public static class ClassTableNotClosed extends ClassNotWellFormed {
    public ClassTableNotClosed(String message) {
      super(message);
    }
  }
}
