package structure.resource;

import structure.astNode.Ast.BaseClassValue;
import structure.astNode.Ast.ClassName;
import structure.integrity.IntegrityChecker;
import tools.Assertions;
import tools.FileManager;
import visitors.VisitorTranslateZero;

import compiler.Mfjc;

public class GreenResource implements IResource {
  public GreenResource(ClassName name) {
    super();
    this.name = name;
  }
  public final ClassName name;
  @Override
  public ClassName getName() {
    return name;
  }
  @Override
  public BaseClassValue getValue() {
    return retrive(name);
  }
  @Override
  public String toString() {
    return IResource.Static.resourceToString(this);
  }
  private static BaseClassValue retrive(ClassName cn) {
    try {
      return retriveAux(cn);
    } catch (SecurityException e) {
      throw Assertions.reflectionError("", e);
    } catch (IllegalArgumentException e) {
      throw Assertions.reflectionError("", e);
    } catch (NoSuchFieldException e) {
      throw Assertions.reflectionError("", e);
    } catch (ClassNotFoundException e) {
      throw Assertions.reflectionError("", e);
    } catch (IllegalAccessException e) {
      throw Assertions.reflectionError("", e);
    }
  }
  private static BaseClassValue retriveAux(ClassName cn) throws SecurityException, NoSuchFieldException, ClassNotFoundException,
      IllegalArgumentException, IllegalAccessException {
    Class<?> clazz = FileManager.loadClassDiskWait(VisitorTranslateZero.cName(cn.value), Mfjc.getLoader());
    java.lang.reflect.Field f = clazz.getField(IntegrityChecker.forbiddenPrefix + VisitorTranslateZero.thisBaseClassValue);
    Object o = f.get(null);
    return (BaseClassValue) o;
    
  }
}
