package structure.resource;

import lowLevel.eval.Eval.CompiledExpression;
import structure.astNode.Ast.*;

/*
metap resource
metapj yellow1
pj- yellow2
pj green */
public interface YellowResource extends IResource {
  public static class MetaYellowResource implements YellowResource {
    public MetaYellowResource(ClassName name, Expression value, CompiledExpression expression) {
      super();
      this.name = name;
      this.value = value;
      this.expression = expression;
    }
    public final ClassName name;
    public final CompiledExpression expression;
    public final Expression value;
    
    @Override
    public ClassName getName() {
      return name;
    }
    @Override
    public Expression getValue() {
      return value;
    }
    @Override
    public String toString() {
      return IResource.Static.resourceToString(this);
    }
  }
  public static class NormalizedYellowResource implements YellowResource {
    public NormalizedYellowResource(ClassName name, BaseClassValue expression) {
      super();
      this.name = name;
      this.expression = expression;
    }
    public final ClassName name;
    public final BaseClassValue expression;
    @Override
    public ClassName getName() {
      return name;
    }
    @Override
    public Expression getValue() {
      return expression;
    }
    @Override
    public String toString() {
      return IResource.Static.resourceToString(this);
    }
  }
}
