package tools;

import java.io.*;
import java.util.ArrayList;

public class FileManager {
  
  // Deletes all files and subdirectories under dir.
  // Returns true if all deletions were successful.
  // If a deletion fails, the method stops attempting to delete and returns false.
  public static boolean deleteDir(File dir) {
    if (dir.isDirectory()) {
      String[] children = dir.list();
      for (int i = 0; i < children.length; i++) {
        boolean success = deleteDir(new File(dir, children[i]));
        if (!success) { return false; }
      }
    }
    return dir.delete();// can be empty directory or file
  }
  
  public static ArrayList<File> getAllFile(File dir) {
    assert dir.isDirectory();
    ArrayList<File> result = new ArrayList<File>();
    String[] children = dir.list();
    for (int i = 0; i < children.length; i++)
      result.add(new File(dir, children[i]));
    return result;
  }
  
  public static File createNew(File n) {
    n.mkdirs();
    return n;
  }
  public static File createNew(File dir, String name) {
    assert dir.isDirectory() : dir;
    return createNew(new File(dir, name));
  }
  
  static public String readFirstLine(File f) {
    BufferedReader file = null;
    try {
      file = new BufferedReader(new FileReader(f));
    } catch (FileNotFoundException e) {
      throw new Error(e);
    }
    try {
      if (file.ready()) return file.readLine();
      throw new Error();
    } catch (IOException e) {
      throw new Error(e);
    }
  }
  
  // static public String loadFile(File fileName) {}
  static public String loadFile(String fileName) {
    return loadFile(new File(fileName));
  }
  
  static public String loadFile(File fileN) {
    // FileInputStream fileStream=new FileInputStream(filename);
    BufferedReader file = null;
    try {
      file = new BufferedReader(new FileReader(fileN));
    } catch (FileNotFoundException e) {
      throw new Error(e);
    }
    StringBuffer s = new StringBuffer();
    try {
      while (file.ready())
        s.append(file.readLine() + "\n");
    } catch (IOException e) {
      throw new Error(e);
    }
    return s.toString();
  }
  
  public static Class<?> loadClassDiskWait(String className, ClassLoader l) throws ClassNotFoundException {
    try {
      return Class.forName(className, true, l);
    } catch (ClassNotFoundException e) {
      System.gc();
      try {
        return Class.forName(className, true, l);
      } catch (ClassNotFoundException e1) {
        for (int i = 0; i < 10; i++) {
          try {
            Thread.sleep(50);
            return Class.forName(className, true, l);
          } catch (InterruptedException e2) {}//
          catch (ClassNotFoundException e3) {}
        }
        return Class.forName(className, true, l);
      }
    }
  }
}
