package visitors;

import structure.astNode.Ast.*;
import structure.astNode.Ast.StringValue;

public interface Visitor<T> {
  T visit(IntValue e);
  T visit(StringValue e);
  T visit(BoolValue e);
  T visit(ClassNameValue e);
  T visit(MemberNameValue e);
  T visit(ClassName e);
  T visit(MemberName e);
  T visit(VariableName e);
  T visit(VariableAccess e);
  T visit(InternalFieldAccess e);
  T visit(InternalMethodCall e);
  T visit(ClientFieldAccess e);
  T visit(ClientMethodCall e);
  T visit(BaseClassValue e);
  T visit(ParamsDec e);
  T visit(ParamsUse e);
  T visit(Constructor e);
  T visit(Field e);
  T visit(AbstractField e);
  T visit(Method e);
  T visit(Block e);
  T visit(If e);
  T visit(While e);
  T visit(VariableDeclaration e);
  T visit(Return e);
  T visit(AbstractMethod e);
  T visit(New e);
  T visit(NewArray e);
  T visit(Print e);
  T visit(BinOpExp e);
  T visit(UnOpExp e);
  T visit(RestrictExp e);
  T visit(AliasExp e);
  T visit(RedirectExp e);
  T visit(StmExp stmExp);
  T visit(VariableAssignament variableAssignament);
  T visit(Throw throw1);
  T visit(AccessArray accessArray);
  T visit(GetMembers getMember);
  T visit(Try try1);
  T visit(Foreach foreach);
}