package visitors;

import org.antlr.runtime.RecognitionException;

import structure.astNode.Ast;
import structure.astNode.Ast.*;
import structure.integrity.ClassNotWellFormed;
import tools.DataStructures.WrapperException;

public class VisitorCheckMainExpression extends VisitorReader {
  
  private static VisitorCheckMainExpression instance = new VisitorCheckMainExpression();
  public static void run(Ast e) throws RecognitionException {
    try {
      e.accept(instance);
    } catch (WrapperException f) {
      throw (RecognitionException) f.wrappedElement;
    }
  }
  
  @Override
  public NoResult visit(VariableAccess e) {
    throw new WrapperException(new ClassNotWellFormed.UndefinedVariableAccess(e.value.value));
  }
  @Override
  public NoResult visit(InternalFieldAccess e) {
    throw new WrapperException(new ClassNotWellFormed.UnboundInternalName(e.value.value));
  }
  @Override
  public NoResult visit(InternalMethodCall e) {
    throw new WrapperException(new ClassNotWellFormed.UnboundInternalName(e.value.value));
  }
  
}
