package visitors;

import structure.astNode.Ast.*;

public class VisitorMemberAlias extends VisitorCloneMember {
  MemberName newName;
  public VisitorMemberAlias(MemberName newName) {
    this.newName = newName;
  }
  @Override
  public Field visit(Field e) {
    return new Field(e.type, newName);
  }
  @Override
  public AbstractField visit(AbstractField e) {
    return new AbstractField(e.type, newName);
  }
  @Override
  public Method visit(Method e) {
    return new Method(e.returnType, newName, e.params, e.body);
  }
  
  @Override
  public AbstractMethod visit(AbstractMethod e) {
    return new AbstractMethod(e.returnType, newName, e.params);
  }
}